<template>
	<a-card :bordered="false">
		<a-form ref="searchFormRef" name="advanced_search" :model="searchFormState" class="ant-advanced-search-form mb-4">
			<a-row :gutter="24">
				<a-col :span="4">
					<a-form-item label="企业客户" name="depotId">
						<a-select v-model:value="searchFormState.depotId" placeholder="请选择企业客户" :options="depotOptions"/>
					</a-form-item>
				</a-col>
				<a-col :span="4">
					<a-form-item label="监管类型" name="siteType">
						<a-select v-model:value="searchFormState.siteType" placeholder="请选择监管类型" :options="siteTypeOptions"/>
					</a-form-item>
				</a-col>
				<a-col :span="4">
					<a-form-item label="监管信息" name="siteMsg">
						<a-input v-model:value="searchFormState.siteMsg" placeholder="请输入监管信息"/>
					</a-form-item>
				</a-col>
				<a-col :span="4">
					<a-form-item label="处理状态" name="saveState">
						<a-select v-model:value="searchFormState.saveState" placeholder="请选择处理状态" :options="saveStateOptions"/>
					</a-form-item>
				</a-col>
				<a-col :span="4">
					<a-form-item label="处理信息" name="saveMsg">
						<a-input v-model:value="searchFormState.saveMsg" placeholder="请输入处理信息"/>
					</a-form-item>
				</a-col>
				<a-col :span="4">
					<a-button type="primary" @click="table.refresh(true)">查询</a-button>
					<a-button style="margin: 0 8px" @click="() => searchFormRef.resetFields()">重置</a-button>
					<!--					<a @click="toggleAdvanced" style="margin-left: 8px">
											{{ advanced ? '收起' : '展开' }}
											<component :is="advanced ? 'up-outlined' : 'down-outlined'"/>
										</a>-->
				</a-col>
			</a-row>
		</a-form>
		<s-table
			ref="table"
			:columns="columns"
			:data="loadData"
			:alert="options.alert.show"
			bordered
			:row-key="(record) => record.id"
			:tool-config="toolConfig"
			:row-selection="options.rowSelection"
		>
			<template #operator class="table-operator">
				<!--				<a-space>
									<a-button type="primary" @click="formRef.onOpen()" v-if="hasPerm('depotFlyerSiteLogWarnAdd')">
										<template #icon>
											<plus-outlined/>
										</template>
										新增
									</a-button>
									<a-button danger @click="deleteBatchDepotFlyerSiteLogWarn()" v-if="hasPerm('depotFlyerSiteLogWarnBatchDelete')">删除</a-button>
								</a-space>-->
			</template>
			<template #bodyCell="{ column, record }">
				<template v-if="column.dataIndex === 'action'">
					<a-space>
						<a @click="detailFormRef.onOpen(record)">详情</a>
						<a @click="formRef.onOpen(record)" v-if="hasPerm('飞行监管异常处理') && '待处理处理中'.indexOf(record.saveState) > -1">
							<a-divider type="vertical"/>
							待处理</a>
						<a-popconfirm title="确定要处理通过吗？" @confirm="bankOpApprovalState(record)">
							<a v-if="hasPerm('飞行监管异常确认') && record.saveState === '已处理'">
								<a-divider type="vertical"/>
								待确认</a>
						</a-popconfirm>
					</a-space>
				</template>
			</template>
		</s-table>
	</a-card>
	<Form ref="formRef" @successful="table.refresh(true)"/>
	<DetailForm ref="detailFormRef"/>
</template>

<script setup name="depotFlyerSiteLogWarn">
import {message} from 'ant-design-vue'
import tool from '@/utils/tool'
import Form from './form.vue'
import DetailForm from '../depotFlyerSiteLog/detailForm.vue'
import depotFlyerSiteLogWarnApi from '@/api/biz/depotFlyerSiteLogWarnApi'
import depotFlyerSiteLogApi from '@/api/biz/depotFlyerSiteLogApi'
import dictOptionsApi from "@/api/biz/dictOptionsApi";
import depotRepayOrderApi from "@/api/biz/depotRepayOrderApi";

let searchFormState = reactive({})
const searchFormRef = ref()
const table = ref()
const formRef = ref()
const detailFormRef = ref()
const depotOptions = ref([])
const toolConfig = {refresh: true, height: true, columnSetting: true, striped: false}
// 查询区域显示更多控制
const advanced = ref(false)
const toggleAdvanced = () => {
	advanced.value = !advanced.value
}
const columns = [
	{
		title: '企业客户',
		dataIndex: 'depotGrainName'
	},
	{
		title: '监管类型',
		dataIndex: 'siteType'
	},
	{
		title: '异常信息',
		dataIndex: 'siteMsg'
	},
	{
		title: '处理信息',
		dataIndex: 'saveMsg'
	},
	{
		title: '处理状态',
		dataIndex: 'saveState'
	},
]
// 操作栏通过权限判断是否显示
columns.push({
	title: '操作',
	dataIndex: 'action',
	align: 'center',
	width: '150px'
})
let selectedRowKeys = ref([])
// 列表选择配置
const options = {
	alert: {
		show: false,
		clear: () => {
			selectedRowKeys = ref([])
		}
	},
	rowSelection: {
		onChange: (selectedRowKey, selectedRows) => {
			selectedRowKeys.value = selectedRowKey
		}
	}
}
dictOptionsApi.options(Object.assign('', {'dictValue': '粮库'})).then((data) => {
	depotOptions.value = data
})
const loadData = (parameter) => {
	const searchFormParam = JSON.parse(JSON.stringify(searchFormState))
	return depotFlyerSiteLogWarnApi.depotFlyerSiteLogWarnPage(Object.assign(parameter, searchFormParam)).then((data) => {
		return data
	})
}
// 删除
const deleteDepotFlyerSiteLogWarn = (record) => {
	let params = [
		{
			id: record.id
		}
	]
	depotFlyerSiteLogWarnApi.depotFlyerSiteLogWarnDelete(params).then(() => {
		table.value.refresh(true)
	})
}
// 批量删除
const deleteBatchDepotFlyerSiteLogWarn = () => {
	if (selectedRowKeys.value.length < 1) {
		message.warning('请选择一条或多条数据')
		return false
	}
	const params = selectedRowKeys.value.map((m) => {
		return {
			id: m
		}
	})
	depotFlyerSiteLogWarnApi.depotFlyerSiteLogWarnDelete(params).then(() => {
		table.value.clearRefreshSelected()
	})
}
// 处理确认
const bankOpApprovalState = (record) => {
	depotFlyerSiteLogApi.depotFlyerSiteLogProcessFinish({id: record.id}).then(() => {
		table.value.refresh(true)
	})
}
const siteTypeOptions = tool.dictList('飞行监管类型')
const saveStateOptions = tool.dictList('处理确认状态')
const processPassOptions = tool.dictList('验收结果')
</script>
